<?php
    //define("BE_CONSOLE",1);
    class DiyoVM_Module extends ServerModule
    {
        private $api,$diyovm;
        function __construct($server,$options = []){
            $this->_name = __CLASS__;
            parent::__construct($server,$options);
        }
        protected function define_server_info($server=[]){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->diyovm = [
                "address" => $_POST["name"],
                "username" => $_POST["username"],
                "password" => $_POST["password"]
            ];
        }
        public function testConnect(){
            $connection = $this->api->beTestConnection($this->diyovm);
            if(!$connection["status"]){
                $this->error = $connection["message"];
                return false;
            }
            return true;
        }
        public function config_options($data = []){
            return [
                "clusterId" => [
                    "name"              => "Cluster",
                    "description"       => "DiyoVM sistemindeki cluster değerini girdiğiniz sunucuya kurulur",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["clusterId"]) ? $data["clusterId"]:"",
                    "placeholder"       => ""
                ],
                "hostId" => [
                    "name"              => "Host",
                    "description"       => "DiyoVM sistemindeki host değerini girdiğiniz sunucuya kurulur",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["hostId"]) ? $data["hostId"]:"",
                    "placeholder"       => ""
                ],
                "poolId" => [
                    "name"              => "Havuz",
                    "description"       => "DiyoVM sistemindeki havuz değerini girdiğini havuzu kullanır",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["poolId"]) ? $data["poolId"]:"",
                    "placeholder"       => ""
                ],
                "datastoreId" => [
                    "name"              => "Disk",
                    "description"       => "DiyoVM sistemindeki kaynak değerini girdiğini diski kullanır",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["datastoreId"]) ? $data["datastoreId"]:"",
                    "placeholder"       => ""
                ],
                "planId" => [
                    "name"              => "Plan Paketi",
                    "description"       => "DiyoVM sistemindeki paketi girerek direkt kullanın",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["planId"]) ? $data["planId"]:"",
                    "placeholder"       => ""
                ],
                "ipCount" => [
                    "name"              => "IP Adresi(Adet)",
                    "description"       => "Sunucunun kullanacağı ip adresi adetini seçin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["ipCount"]) ? $data["ipCount"]:"",
                    "placeholder"       => ""
                ],
                "ipPlanId" => [
                    "name"              => "IP Adresi Paketi",
                    "description"       => "DiyoVM sistemindeki ip adresi girerek direkt kullanın",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["ipPlanId"]) ? $data["ipPlanId"]:"",
                    "placeholder"       => ""
                ],
                "cpuCore" => [
                    "name"              => "CPU Sayısı(Adet)",
                    "description"       => "Sunucunun işlemcinizde kullanacağı çekirdek sayısını belirtin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuCore"]) ? $data["cpuCore"]:"",
                    "placeholder"       => "2"
                ],
                "cpuPerCount" => [
                    "name"              => "Soket Başına CPU Sayısı",
                    "description"       => "Sunucunuzda 1'den fazla işlemci var ise olacak dağılımı belirtin",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuPerCount"]) ? $data["cpuPerCount"]:"",
                    "placeholder"       => "Bu değeri 1 olarak kullanmanızı tavsiye ederiz"
                ],
                "cpuLimitMhz" => [
                    "name"              => "CPU Limiti(Mhz)",
                    "description"       => "Sunucunun işlemcinizde kullanabiliceği maksimum limiti belirleyin, boş bırakırsanız kullanılmaz",
                    "type"              => "text",
                    "width"             => "100",
                    "value"             => isset($data["cpuLimitMhz"]) ? $data["cpuLimitMhz"]:"",
                    "placeholder"       => "2900"
                ],
                "ramGB" => [
                    "name"              => "Ram Miktarı(GB)",
                    "description"       => "Sunucunun sahip olacağı ram miktarını belirtin",
                    "type"              => "text",
                    "width"             => "1",
                    "value"             => isset($data["ramGB"]) ? $data["ramGB"]:"",
                    "placeholder"       => "1024"
                ],
                "diskGB" => [
                    "name"              => "Disk Miktarı(GB)",
                    "description"       => "Sunucunun sahip olacağı disk miktarını belirtin",
                    "type"              => "text",
                    "width"             => "20",
                    "value"             => isset($data["diskGB"]) ? $data["diskGB"]:"",
                    "placeholder"       => "1024"
                ],
                "bandwithGB" => [
                    "name"              => "Bant Genişliği(GB)",
                    "description"       => "Sunucunun sahip olacağı bant genişliği miktarını belirtin",
                    "type"              => "text",
                    "width"             => "10",
                    "value"             => isset($data["bandwithGB"]) ? $data["bandwithGB"]:"",
                    "placeholder"       => "1024"
                ],
                "snapShotCount" => [
                    "name"              => "Yedek Hakkı",
                    "description"       => "Sunucunun alabiliceği yedek hakkını belirleyin (Olmaması İçin 0)",
                    "type"              => "text",
                    "width"             => "3",
                    "value"             => isset($data["snapShotCount"]) ? $data["snapShotCount"]:"",
                    "placeholder"       => "0"
                ],
                "formatOsList" => [
                    "name"              => "Format Şablon Listesi",
                    "description"       => "Eğer özel olarak sadece belirli şablonları kullanarak format atılmasını istiyorsanız bu kısma girin",
                    "type"              => "text",
                    "width"             => "3",
                    "value"             => isset($data["formatOsList"]) ? $data["formatOsList"]:"",
                    "placeholder"       => "5,7"
                ],
                "formatCount" => [
                    "name"              => "Format Hakkı",
                    "description"       => "Bir ay içerisinde atabileceği format hakkı",
                    "type"              => "text",
                    "width"             => "3",
                    "value"             => isset($data["formatCount"]) ? $data["formatCount"]:"",
                    "placeholder"       => "3"
                ]
            ];
        }
        public function create(array $order_options=[]){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $selects = $this->val_of_conf_opt;
            $options = $this->order["options"];
            $basic_vals = $options["creation_info"];
            $extra_vals = [
                "clusterId" => "set",
                "hostId" => "set",
                "poolId" => "set",
                "datastoreId" => "set",
                "osId" => "set",
                "planId" => "set",
                "ipCustom" => "set",
                "ipPlanId" => "set",
                "ipCount" => "option",
                "cpuCore" => "option",
                "cpuPerCount" => "set",
                "cpuLimitMhz" => "set",
                "ramGB" => "option",
                "diskGB" => "option",
                "bandwithGB" => "option",
                "snapShotCount" => "option",
                "userPassword" => "set"
            ];
            foreach($basic_vals as $key => $value){
                $basic_vals[$key] = $value;
            }
            foreach($extra_vals as $key => $value){
                if(empty($selects[$key])){
                    continue;
                }
                if($value == "set"){
                    $basic_vals[$key] = $selects[$key];
                }
                else{
                    $basic_vals[$key."Extra"] = $selects[$key];
                }
            }
            $basic_vals["userMail"] = $this->user["email"];
            $response = $this->api->beCreateVM($basic_vals);
            if(!$response["status"]){
                $this->error = $response["message"];
                self::save_log("Servers",$this->_name, __FUNCTION__,["order" => $this->order],$response["message"],"error");
                return false;
            }
            $firstip = $response["iplist"][0];
            return [
                "ip" => $firstip,
                "assigned_ips" => $response["iplist"],
                "login" => [
                    "username" => $response["username"],
                    "password" => $response["password"],
                ],
                "config" => [
                    $this->entity_id_name => $response["sid"],
                    "taskid" => $response["tid"],
                    "status" => 1
                ]
            ];
        }
        public function suspend(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beSuspend([
                "vm_id" => $config["vm_id"],
                "action" => "suspend"
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                return false;
            }
            $this->options["config"]["status"] = -1;
            Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            return true;
        }
        public function unsuspend(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beSuspend([
                "vm_id" => $config["vm_id"],
                "action" => "unsuspend"
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                return false;
            }
            $this->options["config"]["status"] = 2;
            Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            return true;
        }
        public function terminate(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beDeleteVM([
                "vm_id" => $config["vm_id"]
            ]);
            if(!$response["status"]){
                $this->error = $response["message"];
                self::save_log("Servers",$this->_name,__FUNCTION__,["order" => $this->order],$response["message"],"error");
                return false;
            }
            return true;
        }
        public function apply_updowngrade($params=[])
        {
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            $basic_vals = [
                "vm_id" => $config["vm_id"],
                "planId" => (int)$info["planId"],
                "cpuCore" => (int)$info["cpuCore"],
                "cpuPerCount" => (int)$info["cpuPerCount"],
                "cpuLimitMhz" => (int)$info["cpuLimitMhz"],
                "ramGB" => (int)$info["ramGB"],
                "diskGB" => (int)$info["diskGB"],
                "bandwithGB" => (int)$info["bandwithGB"]
            ];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $config = $this->options["config"];
            $response = $this->api->beUpdateVM($basic_vals);
            if(!$response["status"]){
                $this->error = $response["message"];
                self::save_log("Servers",$this->_name,__FUNCTION__,["order" => $this->order],$response["message"],"error");
                return false;
            }
            return true;
        }
        public function get_status(){
            return true;
        }
        public function list_vps(){
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVms([]);
            if(!$response["status"]){
                $this->error = $response["message"];
                return false;
            }
            $serverlist = [];
            foreach($response["servers"] as $server){
                $sdata = json_decode($server["sdata"],true);
                $hostname = $sdata["hostname"];
                $primary_ip = $server["sip"];
                $serverlist[$hostname."|".$primary_ip] = [
                    "cdate" => date("Y-m-d",$server["sdateline"]),
                    "hostname" => $hostname,
                    "ip" => $primary_ip,
                    "assigned_ips" => explode(",",$sdata["iplist"]),
                    "login" => [
                        "username" => $sdata["config"]["username"],
                        "password" => $sdata["config"]["password"],
                    ],
                    "sync_terms" => self::sync_terms($primary_ip,$hostname),
                    "access_data" => [
                        $this->entity_id_name => $server["sid"]
                    ]
                ];
            }
            return $serverlist;
        }
        public function use_clientArea_entegration(){
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $type = $_POST["type"];
            switch($type){
                case "network" : 
                    $response = $this->api->beEntegrationNetwork([
                        "vm_id" => $config["vm_id"]
                    ]);
                    break;
                case "disc" :
                    $response = $this->api->beEntegrationDisc([
                        "vm_id" => $config["vm_id"]
                    ]);
                    break;
                default:
                    echo json_encode(["status" => false,"message" => "Belirtilen işlem bulunamadı!"]);
                    exit;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function diyovm_menu_password(){
            return $this->get_page("password",[
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        function use_clientArea_password_change(){
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $password = htmlspecialchars($_POST["password"]);
            $password_e = $this->encode_str($password);
            $response = $this->api->bePasswordVM([
                "vm_id" => $config["vm_id"],
                "onserver" => true,
                "password" => $password
            ]);
            if($response["status"]){
                $this->options["login"]["password"] = $password_e;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function diyovm_menu_console(){
            if(!defined("BE_CONSOLE")){
                return "Belirtilen firma üzerinde DiyoVM Konsol modülü bulunmamaktadır. Bu yüzden konsola erişemezsiniz!";
            }
            
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVmConsole([
                "vm_id" => $config["vm_id"]
            ]);
            if(!$response["status"]){
                return $response["message"];
            }
            return $this->get_page("console",[
                "console_url" => $response["url"],
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function diyovm_menu_format(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "templatelist" => true,
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            $templatelist = $response["templatelist"];
            $pid = (int)$info["planId"];
            if($pid){
                $response = $this->api->beGetPlans([
                    "pid" => $pid
                ]);
                if(!$response["status"]){
                    return $response["message"];
                }
                $plan = $response["plans"][0];
                if($plan["ptemplates"] != "-1"){
                    $ptemplates = explode(",",$plan["ptemplates"]);
                    foreach($templatelist as $key => $template){
                        if(!in_array($template["tid"],$ptemplates)){
                            unset($templatelist[$key]);
                        }
                    }
                }
            }
            $ptemplates = $info["formatOsList"];
            if($ptemplates){
                $ptemplates = explode(",",$ptemplates);
                foreach($templatelist as $key => $template){
                    if(!in_array($template["tid"],$ptemplates)){
                        unset($templatelist[$key]);
                    }
                }
            }
            $formatdeserve = (int)$info["formatCount"];
            $formatcount = $this->options["config"]["formatcount"] ?? 0;
            $formatright = $formatdeserve-$formatcount;
            if($formatright < 1){
                $formatright = 0;
            }
            return $this->get_page("format",[
                "formatdeserve" => $formatdeserve,
                "formatright" => $formatright,
                "templatelist" => $templatelist,
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function use_clientArea_format(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($config["status"] != 2){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için kurulu olması gerek!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!$_POST["approval"]){
                echo json_encode(["status" => false,"message" => "Lütfen tüm bilgilerinizin siliniceğini onaylayın!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "templatelist" => true,
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            $templatelist = $response["templatelist"];
            $formatcount = $this->options["config"]["formatcount"] ?? 0;
            $formattimefirst = $this->options["config"]["firsttime"] ?? 0;
            $formatdeserve = $info["formatCount"] ?? 3;
            $timenow = time();
            if($formatdeserve > 0){
                if($formatcount >= $formatdeserve){
                    if($timenow-$formattimefirst < 2592000){
                        echo json_encode(["status" => false,"message" => "Bir ay içerisinde tüm format haklarınızı kullandınız tekrardan dolmasına: ".(round(($timenow-$formattimefirst+2592000)/86400))." gün kaldı!"],JSON_UNESCAPED_UNICODE);
                        return false;
                    }
                    else{
                        $this->options["config"]["formatcount"] = 0;
                        $this->options["config"]["firsttime"] = $timenow;
                        Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                    }
                }
                else{
                    if(!$formattimefirst){
                        $this->options["config"]["firsttime"] = $timenow;
                    }
                    $this->options["config"]["formatcount"] += 1;
                    Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                }
            }
            $ptemplates = $info["formatOsList"];
            if($ptemplates){
                $ptemplates = explode(",",$ptemplates);
                foreach($templatelist as $key => $template){
                    if(!in_array($template["tid"],$ptemplates)){
                        unset($templatelist[$key]);
                    }
                }
            }
            $pid = (int)$info["planId"];
            if($pid){
                $response = $this->api->beGetPlans([
                    "pid" => $pid
                ]);
                if(!$response["status"]){
                    return $response["message"];
                }
                $plan = $response["plans"][0];
                if($plan["ptemplates"] != "-1"){
                    $ptemplates = explode(",",$plan["ptemplates"]);
                    foreach($templatelist as $key => $template){
                        if(!in_array($template["tid"],$ptemplates)){
                            unset($templatelist[$key]);
                        }
                    }
                }
            }
            $tid = (int)$_POST["template"];
            $passed = false;
            foreach($templatelist as $template){
                if($template["tid"] == $tid){
                    $passed = true;
                    break;
                }
            }
            if(!$passed){
                echo json_encode(["status" => false,"message" => "Bu işletim sistemi kullanabiliceğiniz işletim sistemleri arasında değil!"]);
                exit;
            }
            $password = htmlspecialchars($_POST["password"]);
            $response = $this->api->beFormatVM([
                "vm_id" => $config["vm_id"],
                "template" => $tid,
                "password" => $password
            ]);
            if($response["status"]){
                $this->options["login"]["password"] = $password;
                $this->options["config"]["taskid"] = $response["taskid"];
                $this->options["config"]["status"] = 1;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                $response["url"] = $module->area_link."?m_page=home";
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function diyovm_menu_ip(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "iplist" => true,
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            return $this->get_page("ip",[
                "iplist" => $response["iplist"],
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function diyovm_menu_rdns(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "iplist" => true,
                "rdnslist" => true,
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            $rdnsstatuslist = [
                -1 => [
                    "name" => "Reddedildi",
                    "color" => "btn-danger"
                ],
                1 => [
                    "name" => "İşlemde",
                    "color" => "btn-primary"
                ],
                2 => [
                    "name" => "Aktif",
                    "color" => "btn-success"
                ]
            ];
            return $this->get_page("rdns",[
                "iplist" => $response["iplist"],
                "rdnslist" => $response["rdnslist"],
                "rdnsstatuslist" => $rdnsstatuslist,
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function diyovm_menu_rdns_create(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "iplist" => true
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            return $this->get_page("rdnscreate",[
                "iplist" => $response["iplist"],
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function use_clientArea_rdns_create(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için kurulu olması gerek!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beCreateDnsRecord([
                "vm_id" => $config["vm_id"],
                "iid" => (int)$_POST["iid"],
                "type" => $_POST["type"],
                "dns" => $_POST["dns"],
                "priority" => (int)$_POST["priority"],
                "ttl" => (int)$_POST["ttl"],
            ]);
            if($response["status"]){
                $response["url"] = $module->area_link."?m_page=rdns";
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function diyovm_menu_rdns_edit(){
            $rid = (int)$_GET["rid"];
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "iplist" => true,
                "rdnslist" => true
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            $rdns = [];
            foreach($response["rdnslist"] as $rdnslist){
                if($rdnslist["rid"] == $rid){
                    $rdns = $rdnslist;
                    break;
                }
            }
            if(!$rdns){
                return "Belirtilen rDNS kaydı sistem üzerinde bulunamadı!";
            }
            return $this->get_page("rdnsedit",[
                "iplist" => $response["iplist"],
                "rdns" => $rdns,
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function use_clientArea_rdns_edit(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için kurulu olması gerek!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beEditDnsRecord([
                "vm_id" => $config["vm_id"],
                "rid" => (int)$_POST["rid"],
                "iid" => (int)$_POST["iid"],
                "type" => $_POST["type"],
                "dns" => $_POST["dns"],
                "priority" => (int)$_POST["priority"],
                "ttl" => (int)$_POST["ttl"],
            ]);
            if($response["status"]){
                $response["url"] = $module->area_link."?m_page=rdns";
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function use_clientArea_rdns_delete(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            if($config["status"] != 2){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için kurulu olması gerek!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeleteDnsRecord([
                "vm_id" => $config["vm_id"],
                "rid" => (int)$_POST["rid"]
            ]);
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function diyovm_menu_snapshot(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "snapshotlist" => true
            ]);
            return $this->get_page("snapshot",[
                "snapshotlist" => $response["snapshotlist"],
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function use_clientArea_snapshot_create(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($config["status"] != 2){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için kurulu olması gerek!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if($info["snapShotCount"] == 0){
                echo json_encode(["status" => false,"message" => "Sunucunuzuz bu işlem için izni yok!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "snapshotlist" => true
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                return false;
            }
            $snapshotlist = $response["snapshotlist"] ?? [];
            if(count($snapshotlist) >= $info["snapShotCount"]){
                echo json_encode(["status" => false,"message" => "Maksimum yedek sayısına ulaştınız!"],JSON_UNESCAPED_UNICODE);
                return false;
            }
            $response = $this->api->beCreateSnapshot([
                "vm_id" => $config["vm_id"]
            ]);
            if($response["status"]){
                $response["refresh"] = 1;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function use_clientArea_snapshot_deploy(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeploySnapshot([
                "vm_id" => $config["vm_id"],
                "ssid" => $_POST["ssid"]
            ]);
            if($response["status"]){
                $response["refresh"] = 1;
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function use_clientArea_snapshot_delete(){
            if(!Filter::isPOST()){
                return false;
            }
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beDeleteSnapshot([
                "vm_id" => $config["vm_id"],
                "ssid" => $_POST["ssid"]
            ]);
            if($response["status"]){
                $response["url"] = $module->area_link."?m_page=home";
            }
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function diyovm_menu_logs(){
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if(!class_exists("beDiyoApi")){
                require __DIR__."/be_system.php";
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "logs" => true
            ]);
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                exit;
            }
            if(!$response["status"]){
                echo json_encode(["status" => false,"message" => $response["message"]],JSON_UNESCAPED_UNICODE);
                return false;
            }
            return $this->get_page("logs",[
                "logs" => $response["logs"],
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        public function clientArea(){
            $menu = $this->page;
            $config = $this->options["config"];
            $info = $this->options["creation_info"];
            if($menu && $menu != "home"){
                if(!in_array($menu,["password","console","ip","rdns","rdns_create","rdns_edit","snapshot","logs","format"])){
                    return "Belirtilen menü sistem üzerinde bulunamadı!";
                }
                return call_user_func([$this,"diyovm_menu_".$menu]);
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
                "templatelist" => true
            ]);
            if(!$response["status"]){
                return $response["message"];
            }
            $vm = $response["server"];
            $templatelist = $response["templatelist"] ?? [];
            $vm["sdata"] = json_decode($vm["sdata"],true);
            if($vm["sdata"]["formatting"] != 0){
                $this->options["config"]["taskid"] = $vm["sdata"]["formatting"];
                $this->options["config"]["status"] = 1;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                return $this->get_page("formatarea");
            }
            else{
                $this->options["config"]["status"] = 2;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
            }
            foreach($templatelist as $template){
                if($vm["sdata"]["template"] == $template["tid"]){
                    $vm["sdata"]["templatename"] = $template["tname"];
                }
            }
            Helper::Load("Money");
            $periods = ["month" => "Aylık","year" => "Yıllık"];
            $orderinfo = [
                "product" => $this->order["name"],
                "billingcycle" => $periods[$this->order["period"]],
                "regdate" => date("d.m.Y",strtotime($this->order["renewaldate"])),
                "nextduedate" => date("d.m.Y",strtotime($this->order["duedate"])),
                "amount" => Money::formatter($this->order["amount"],$this->order["amount_cid"])." ".Money::getSymbol($this->order["amount_cid"])["symbol"],
                "paymethod" => $this->order['pmethod']
            ];
            if(!$vm["sdata"]["stats"]["uptime"]){
                $vm["sdata"]["stats"]["uptime"] = 0;
            }
            if(!$vm["slastcheck"]){
                $vm["slastcheck"] = 0;
            }
            $vminfo = [
                "power" => $vm["sdata"]["stats"]["power_status"],
                "uptime" => round($vm["sdata"]["stats"]["uptime"]/60),
                "lastcheck" => round((time()-$vm["slastcheck"])/60),
                "templatename" => $vm["sdata"]["templatename"],
                "ipaddres" => $vm["sip"],
                "username" => $vm["sdata"]["config"]["username"],
                "password" => $vm["sdata"]["config"]["password"]
            ];
            $usageinfo = [
                "cpu_usage" => $vm["sdata"]["stats"]["cpu_mhz"],
                "cpu_max" => round($vm["sdata"]["settings"]["core"]*$vm["sdata"]["stats"]["cpu_hz"]*1000),
                "cpu_percent" => $vm["sdata"]["stats"]["cpu_percent"],
                "cpu_type" => "MHZ",
                "ram_usage" => $vm["sdata"]["stats"]["ram_mb"],
                "ram_max" => $vm["sdata"]["settings"]["ram"],
                "ram_percent" => $vm["sdata"]["stats"]["ram_percent"],
                "ram_type" => "MB",
                "disk_usage" => $vm["sdata"]["stats"]["disk_gb"],
                "disk_max" => $vm["sdata"]["settings"]["disk"],
                "disk_percent" => $vm["sdata"]["stats"]["disk_percent"],
                "network_usage" => $vm["sdata"]["stats"]["network"],
                "network_type" => "KB/sn"
            ];
            if($usageinfo["ram_usage"] > 1024){
                $usageinfo["ram_usage"] /= 1024;
                $usageinfo["ram_usage"] = round($usageinfo["ram_usage"],2);
                $usageinfo["ram_type"] = "GB";
            }
            if($usageinfo["cpu_usage"] > 1024){
                $usageinfo["cpu_usage"] /= 1000;
                $usageinfo["cpu_usage"] = round($usageinfo["cpu_usage"],2);
                $usageinfo["cpu_type"] = "GHZ";
            }
            if($usageinfo["cpu_percent"] > 60){
                $usageinfo["cpu_percent_color"] = "#f1416c";
            }
            else if($usageinfo["cpu_percent"] > 30){
                $usageinfo["cpu_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["cpu_percent_color"] = "#009ef7";
            }
            if($usageinfo["ram_percent"] > 60){
                $usageinfo["ram_percent_color"] = "#f1416c";
            }
            else if($usageinfo["ram_percent"] > 30){
                $usageinfo["ram_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["ram_percent_color"] = "#009ef7";
            }
            if($usageinfo["disk_percent"] > 60){
                $usageinfo["disc_percent_color"] = "#f1416c";
            }
            else if($usageinfo["disk_percent"] > 30){
                $usageinfo["disc_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["disc_percent_color"] = "#009ef7";
            }
            return $this->get_page("index",[
                "orderinfo" => $orderinfo,
                "vminfo" => $vminfo,
                "usageinfo" => $usageinfo,
                "url" => $this->url,
                "lang" => $this->lang
            ]);
        }
        function use_clientArea_power_action(){
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => $_POST["process"]
            ]);
            $response["refresh"] = true;
            echo json_encode($response,JSON_UNESCAPED_UNICODE);
        }
        public function use_clientArea_check_stat(){
            $config = $this->options["config"];
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"https://{$this->server['name']}/app/tasks/statserver.php?vmlist={$config['vm_id']}");
            curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
            curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
            curl_exec($ch);
            curl_close($ch);
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"],
            ]);
            $vm = $response["server"];
            $vm["sdata"] = json_decode($vm["sdata"],true);
            $usageinfo = [
                "cpu_usage" => $vm["sdata"]["stats"]["cpu_mhz"],
                "cpu_max" => round($vm["sdata"]["settings"]["core"]*$vm["sdata"]["stats"]["cpu_hz"]*1000),
                "cpu_percent" => $vm["sdata"]["stats"]["cpu_percent"],
                "cpu_type" => "MHZ",
                "ram_usage" => $vm["sdata"]["stats"]["ram_mb"],
                "ram_max" => $vm["sdata"]["settings"]["ram"],
                "ram_percent" => $vm["sdata"]["stats"]["ram_percent"],
                "ram_type" => "MB",
                "disc_usage" => $vm["sdata"]["stats"]["disk_gb"],
                "disc_max" => $vm["sdata"]["settings"]["disk"],
                "disc_percent" => $vm["sdata"]["stats"]["disk_percent"],
                "network_usage" => $vm["sdata"]["stats"]["network"],
                "network_type" => "KB/sn"
            ];
            if($usageinfo["ram_usage"] > 1024){
                $usageinfo["ram_usage"] /= 1024;
                $usageinfo["ram_usage"] = round($usageinfo["ram_usage"],2);
                $usageinfo["ram_type"] = "GB";
            }
            if($usageinfo["cpu_usage"] > 1024){
                $usageinfo["cpu_usage"] /= 1000;
                $usageinfo["cpu_usage"] = round($usageinfo["cpu_usage"],2);
                $usageinfo["cpu_type"] = "GHZ";
            }
            if($usageinfo["cpu_percent"] > 60){
                $usageinfo["cpu_percent_color"] = "#f1416c";
            }
            else if($usageinfo["cpu_percent"] > 30){
                $usageinfo["cpu_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["cpu_percent_color"] = "#009ef7";
            }
            if($usageinfo["ram_percent"] > 60){
                $usageinfo["ram_percent_color"] = "#f1416c";
            }
            else if($usageinfo["ram_percent"] > 30){
                $usageinfo["ram_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["ram_percent_color"] = "#009ef7";
            }
            if($usageinfo["disc_percent"] > 60){
                $usageinfo["disc_percent_color"] = "#f1416c";
            }
            else if($usageinfo["disc_percent"] > 30){
                $usageinfo["disc_percent_color"] = "#ffc700";
            }
            else{
                $usageinfo["disc_percent_color"] = "#009ef7";
            }
            echo json_encode($usageinfo,JSON_UNESCAPED_UNICODE);
            exit;
        }
        public function use_clientArea_check_format2(){
            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL,"https://{$this->server['name']}/app/tasks/createserver.php");
            curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,false);
            curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,false);
            curl_exec($ch);
            echo json_encode([
                "status" => 1
            ],JSON_UNESCAPED_UNICODE);
            curl_close($ch);
        }
        public function use_clientArea_check_format(){
            if(!Filter::isPOST()) return false;
            $config = $this->options["config"];
            if($config["status"] != 1){
                echo json_encode(["refresh" => 1]);
                exit;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetTask([
                "taskid" => $config["taskid"]
            ]);
            if(!$response["status"]){
                echo Utility::jencode([
                    'status' => "error",
                    'message' => $response["message"],
                ]);
                return false;
            }
            $task = $response["task"];

            $laststep = (int)$_POST["laststep"];
            $steps = [
                0 => "Siliniyor!",
                1 => "Kurulum için hazırlanıyor!",
                2 => "Kurulum yapılıyor",
                3 => "Disk Ayarlanıyor",
                4 => "Sunucu Başlatılıyor",
                5 => "Ip adresleri tanımlanıyor!"
            ];
            if($task["tstatus"] == 0){
                $this->options["config"]["status"] = 2;
                Orders::set($this->order["id"],["options" => Utility::jencode($this->options)]);
                echo json_encode(["refresh" => 1]);
                exit;
            }
            $tdata = json_decode($task["tdata"],true);
            $stepnow = $tdata["status"]["step"];
            if($laststep == $stepnow){
                if($stepnow == 2){
                    echo json_encode(["percent" => $tdata["vars"]["percent"]]);
                    exit;
                }
                echo json_encode(["stepnow" => $stepnow]);
                exit;
            }
            $start = 1;
            if($stepnow == 14){
                $start = 0;
                $stepnow = 0;
            }
            $stepscontent = "";
            for($i = $start; $i < 6; $i++){
                if($stepnow > $i){
                    $stepscontent .= "<li class=\"maked\"><span>{$steps[$i]}</span><i class=\"fa fa-check\"></i></li>";
                }
                else if($stepnow == $i){
                    $activestep = $steps[$i];
                    if($i == 2){
                        $extradata = " <span class=\"percentServer\">%".$tdata["vars"]["percent"]."</span>";
                    }
                    $stepscontent .= "<li class=\"active\"><span>{$activestep}{$extradata}</span><i class=\"fa fa-refresh fa-spin\"></i></li>";
                }
                else{
                    $stepscontent .= "<li class=\"waiting\"><span>{$steps[$i]}</span><i class=\"fa fa-close\"></i></li>";
                }
            }
            echo json_encode(["steps" => $stepscontent,"steptext" => $activestep,"stepnow" => $stepnow,"data" => $tdata]);
        }
        public function adminArea_buttons(){
            $buttons = [];
            $config = $this->options["config"];
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            $response = $this->api->beGetVm([
                "vm_id" => $config["vm_id"]
            ]);
            if(!$response["status"]){
                return [];
            }
            $vm = $response["server"];
            $sdata = json_decode($vm["sdata"],true);
            if($sdata["stats"]["power_status"] == 1)
            {
                $buttons["restart"] = [
                    "text"  => $this->lang["restart"],
                    "type"  => "transaction",
                ];
                $buttons["stop"] = [
                    "text"  => $this->lang["stop"],
                    "type"  => "transaction",
                ];
            }
            else
            {
                $buttons["start"] = [
                    "text"  => $this->lang["start"],
                    "type"  => "transaction",
                ];
            }
            return $buttons;
        }
        public function use_adminArea_SingleSignOn(){
            $server = $this->server;
            $config = $this->options["config"];
            Utility::redirect("https://".$server["name"]."/api_login?email=".$server["username"]."&hash=".$server["access_hash"]."&redirect=server&id=".$config["vm_id"]);
            echo "Redirecting...";
        }

        public function use_adminArea_root_SingleSignOn(){
            $server = $this->server;
            Utility::redirect("https://".$server["name"]."/api_login?email=".$server["username"]."&hash=".$server["access_hash"]);
            echo "Redirecting...";
        }
        public function use_adminArea_start(){
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-start');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "start"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
        public function use_adminArea_stop(){
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-stop');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "stop"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
        public function use_adminArea_restart(){
            $config = $this->options["config"];
            if($config["status"] != 2){
                return false;
            }
            if(!class_exists("beDiyoApi")) include __DIR__.DS."be_system.php";
            $this->api = new beDiyoApi();
            $this->api->beSetServer($this->server);
            Orders::add_history($user_id,$this->order["id"],'server-order-restart');
            $response = $this->api->beStatusAction([
                "vm_id" => $config["vm_id"],
                "action" => "restart"
            ]);
            if(!$response["status"]){
                return false;
            }
            return true;
        }
    }
?>